Given two strings s and t, write a function to determine if t is an anagram of s.
You may assume the string contains only lowercase alphabets.
s = “anagram”, t = “nagaram”, return true.
s = “rat”, t = “car”, return false.
没有明确给出。
由于只包含小写英文字母,所以最简单的方法应该是设置一个大小为26的数组用来记录字符串中各个字符的数目。遍历一遍t,增加出现在t中的各个字符的数目,然后遍历s,减少出现在s中的各个字符的数目,如果有某个字符的数目小于0就返回false,最后返回true。对应s和t长度不一致的情况,可以直接返回false。
这道题官方给出了参考解答,其中一种解法就是我的那个解法。另一种解法是对两个字符串排序,然后直接判断是否相等,简单的3行代码就能搞定。(怎么想出来的,这么牛,咋我就没有想到咧)。
class Solution {
public:
bool isAnagram(string s, string t) {
if (s.size() != t.size())
return false;
int letters[26] = {0};
for (auto c: s)
letters[c - 'a']++;
for (auto c: t) {
if (--letters[c - 'a'] < 0)
return false;
}
return true;
}
};
class Solution {
public:
bool isAnagram(string s, string t) {
sort(s.begin(), s.end());
sort(t.begin(), t.end());
return s == t;
}
};
题目还提出了更进一步的问题:
What if the inputs contain unicode characters? How would you adapt your solution to such case?
这个问题是说如果输入的字符串中包含unicode字符,那我们该怎样调整程序以适应这种情况。
我的思路就是暴力破解,s和t的长度不一样时直接返回false,长度相同时,对于t中的每一个元素,都在s中寻找并得到索引位置,如果索引位置无效就返回false,有效就直接从s中删掉该元素。重复这过程直到t所有元素都被找到,此时返回true。
我的这种想法非常低效,对每个字符都要遍历一次字符串,而且从字符串删除元素也会带来额外的开销。
LeetCode上的参考解答是使用一个哈希表代替固定大小的数组,重用上面的记录字符数目的算法即可。
原文的链接
class Solution {
public:
bool isAnagram(string s, string t) {
if (s.size() != t.size())
return false;
for (int i = 0; i < s.size(); i++) {
size_t j = t.find_first_of(s[i]);
if (j != string::npos)
t.erase(j, 1);
else
return false;
}
return true;
}
};
这道题也还是水题,同样思考题也有点意思,算是复习了一下哈希的概念。不得不说,排序的解法真的是很巧妙,尽管效率上不高。
国庆第一天连填两个坑,暂且休息一下,明天一起加油吧,O(∩_∩)O。